=== ns-3.7.1/examples/error-model/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('simple-error-model', ['point-to-point', 'internet-stack'])
    obj.source = 'simple-error-model.cc'
