=== ns-3.7.1/examples/ipv6/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('icmpv6-redirect', ['csma', 'internet-stack'])
    obj.source = 'icmpv6-redirect.cc'

    obj = bld.create_ns3_program('ping6', ['csma', 'internet-stack'])
    obj.source = 'ping6.cc'
    
    obj = bld.create_ns3_program('radvd', ['csma', 'internet-stack'])
    obj.source = 'radvd.cc'

    obj = bld.create_ns3_program('radvd-two-prefix', ['csma', 'internet-stack'])
    obj.source = 'radvd-two-prefix.cc'

    obj = bld.create_ns3_program('test-ipv6', ['point-to-point', 'internet-stack'])
    obj.source = 'test-ipv6.cc'
    
    obj = bld.create_ns3_program('fragmentation-ipv6', ['csma', 'internet-stack'])
    obj.source = 'fragmentation-ipv6.cc'

    obj = bld.create_ns3_program('loose-routing-ipv6', ['csma', 'internet-stack'])
    obj.source = 'loose-routing-ipv6.cc'
