=== debian/changelog ===
ns3 (3.7.1-7) unstable; urgency=low

  * Initial release (Closes: #574471)

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 18 Mar 2010 21:28:35 +0800
