=== debian/watch ===
version=3
http://www.nsnam.org/releases/ns-allinone-([\d.]+)\.tar\.bz2
